#include <bits/stdc++.h>
using namespace std;

int main()
{
    int n; cin >> n;

    vector<int> A(n), B(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> B[i];
    }

    vector<int> prefiksXOR(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        prefiksXOR[i] = prefiksXOR[i - 1] ^ A[i - 1];
    }

    vector<int> prefiksAND(n + 1, -1);
    for (int i = 1; i <= n; i++) {
        prefiksAND[i] = (i == 1) ? B[i - 1] : (prefiksAND[i - 1] & B[i - 1]);
    }

    int maksimalna = 0;
    for (int L = 1; L <= n; L++) {
        for (int R = L; R <= n; R++) {
            int vxor = prefiksXOR[R] ^ prefiksXOR[L - 1];
            int vand = prefiksAND[R];
            if (L > 1)
            {
                vand &= prefiksAND[L - 1];
            }
            int trenutno = vxor * vand;
            maksimalna = max(maksimalna, trenutno);
        }
    }

    cout << maksimalna << endl;

    return 0;
}